@import '../../styles/variables';
@import '../../styles/mixins';

$-cui-toggle-transition-duration: .3s;
$-cui-toggle-label-margin: .5rem;

form > .cui-toggle {
  display: flex;
  margin-bottom: $cui-form-field-margin-bottom;

  + .cui-toggle {
    margin-top: $cui-form-field-margin-bottom * -0.5;
  }
}

.cui-toggle {
  display: inline-flex;

  &.cui-toggle-spread {
    display: flex;
  }

  label {
    @include cui-no-select();
    flex: 1 1 auto;
    display: inline-flex;
    cursor: pointer;
    position: relative;
  }

  .cui-toggle-label {
    @include cui-select();
    @include cui-break-word();
  }

  .cui-toggle-box {
    flex-shrink: 0;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    position: relative;
    transition: background-color $-cui-toggle-transition-duration ease,
    box-shadow $cui-focus-transition;
    overflow: hidden;

    &:after {
      content: " ";
      position: absolute;
      border-radius: 50%;
      transition: transform .1s linear;
      @include cui-elevation(1);
    }
  }

  // ----- align

  .cui-toggle-labeled {
    margin-left: $-cui-toggle-label-margin;
  }

  .cui-toggle-right {
    flex-direction: row-reverse;

    .cui-toggle-labeled {
      margin-left: 0;
      margin-right: $-cui-toggle-label-margin;
      text-align: right;
    }
  }

  .cui-toggle-left-spread {
    justify-content: space-between;
  }

  .cui-toggle-right-spread {
    flex-direction: row-reverse;
    justify-content: space-between;

    .cui-toggle-labeled {
      margin-left: 0;
      margin-right: $-cui-toggle-label-margin;
    }
  }

  // ----- states

  &.cui-toggle-disabled label {
    cursor: not-allowed;
    opacity: $cui-disabled-opacity;
  }

  &.cdk-program-focused,
  &.cdk-keyboard-focused {
    .cui-toggle-box {
      box-shadow: 0 0 0 2px $cui-focus-color;
    }
  }

  // ----- mode (fixed)

  &:not(.cui-toggle-checked) {
    .cui-toggle-box {
      background-color: $cui-n75;

      &:after {
        background-color: $cui-n0;
      }
    }

    &:not(.cui-toggle-disabled) label:hover .cui-toggle-box {
      background-color: $cui-n100;
    }
  }

  &.cui-toggle-checked {
    .cui-toggle-box {
      background-color: cui-color(primary, bg);

      &:after {
        background-color: cui-color(primary, fill);
      }
    }

    &:not(.cui-toggle-disabled) label:hover .cui-toggle-box {
      background-color: cui-color(primary, bg-hover);

      &:after {
        background-color: cui-color(primary, fill-hover);
      }
    }

    &:not(.cui-toggle-disabled) label:active .cui-toggle-box {
      background-color: cui-color(primary, bg-active);

      &:after {
        background-color: cui-color(primary, fill-active);
      }
    }
  }

  // ----- sizes

  @mixin size($size) {
    &[data-cui-size="#{$size}"] {
      $-cui-toggle-width: cui-height($size) - .5rem;
      $-cui-toggle-height: cui-height($size) * .5;
      $-cui-toggle-bullet: cui-height($size) * .35;
      $-cui-toggle-translate: $-cui-toggle-width * .5 -
        $-cui-toggle-bullet * .5 -
        ($-cui-toggle-height - $-cui-toggle-bullet) * .5;

      .cui-toggle-box {
        height: $-cui-toggle-height;
        width: $-cui-toggle-width;
        border-radius: cui-height($size);

        &:after {
          width: $-cui-toggle-bullet;
          height: $-cui-toggle-bullet;
          transform: translateX(-$-cui-toggle-translate);
        }
      }

      &.cui-toggle-checked {
        .cui-toggle-box {
          &:after {
            transform: translateX($-cui-toggle-translate);
          }
        }
      }

      .cui-toggle-label {
        @include cui-text($size);
      }
    }
  }

  @include size('s');
  @include size('m');
  @include size('l');
}
